mysite/events/urls.py
from django.urls import path, include
from . import views  # "." = "this directory" = events
from django.contrib import admin

# app_name = 'events'
urlpatterns = [
    path('', views.home, name="home"),       # home
    path('home/', views.home, name="home"),       # home

   # path('', views.calendar2, name="calendar2"),
   # path('<int:year>/<str:month>', views.calendar2, name="calendar2"),  # calendario statico

    path('calendar', views.calendar, name="calendar"),
    path('calendar/<int:pYear>/<int:pMonth>', views.calendar, name="calendar"), # calendario dinamico

    path('event/<int:pk>/', views.EventView.as_view(), name='event_detail'), # link a evento dentro calendario
    
    path('events', views.all_events, name="list_events"),
    path('sports', views.all_sports, name="list_sports"),
    path('users', views.all_myUsers, name="list_users"),
    path('venues', views.all_venues, name="list_venues"),

    path('add_venue', views.add_venue, name="add_venue"),
    path('add_myUser', views.add_myUser, name="add_myUser"),
    path('add_sport', views.add_sport, name="add_sport"),
    path('add_event', views.add_event, name="add_event"),

    path('update_venue/<venue_id>', views.update_venue, name="update_venue"),
    path('delete_venue/<venue_id>', views.delete_venue, name="delete_venue"),
    path('update_myUser/<myUser_id>', views.update_myUser, name="update_myUser"),
    path('delete_myUser/<myUser_id>', views.delete_myUser, name="delete_myUser"),
    path('update_sport/<sport_id>', views.update_sport, name="update_sport"),
    path('delete_sport/<sport_id>', views.delete_sport, name="delete_sport"),
    path('update_event/<event_id>', views.update_event, name="update_event"),
    path('delete_event/<event_id>', views.delete_event, name="delete_event"),

    path('search_event', views.search_event, name="search_event"),

]

mysite/mysite/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('polls/', include('polls.urls')),  # polls = sondaggi
    path('', include('events.urls')),       # events = eventi per calendario
]

mysite/polls/urls.py
"""mysite URL Configuration"""

from django.urls import path
from . import views

app_name = 'polls'
urlpatterns = [
    path('', views.IndexView.as_view(), name='index'), # ex: /polls/
    path('<int:pk>/', views.DetailView.as_view(), name='detail'),
    # '<int:question_id>/', views.detail, -> ex: /polls/1/
    path('<int:pk>/results/', views.ResultsView.as_view(), name='results'),
    # '<int:question_id>/results/', views.results, -> ex: /polls/1/results/
    path('<int:question_id>/vote/', views.vote, name='vote'), # ex: /polls/1/vote/
]

# remove our old index, detail, and results views and use Django’s generic views : from <question_id> to <pk>.

mysite/events/forms.py
from django import forms
from django.forms import ModelForm
# from models import *model_name*
from .models import Venue
from .models import myUser
from .models import Sport
from .models import Event


# venue form
class VenueForm(ModelForm):
    class Meta: #django define things
        model = Venue
        # fields = "__all__"
        fields = ('name', 'city', 'address', 'zip_code', 'phone', 'web', 'email_address')
        labels = {
            'name': 'Venue Name',
            'city': 'City',
            'address': 'Address',
            'zip_code': 'Zip_code',
            'phone': 'Phone',
            'web': 'Web link',
            'email_address': 'Email Address'
        }
        widgets = {
            'name': forms.TextInput(attrs={'class': 'form-control', 'placeholder': 'Infinity boulder'}),
            'city': forms.TextInput(attrs={'class': 'form-control', 'placeholder': 'Mattarello (TN)'}),
            'address': forms.TextInput(attrs={'class': 'form-control', 'placeholder': 'Località Le Basse, 25'}),
            'zip_code': forms.TextInput(attrs={'class': 'form-control', 'placeholder': '38122'}),
            'phone': forms.TextInput(attrs={'class': 'form-control', 'placeholder': '3457767114'}),
            'web': forms.URLInput(attrs={'class': 'form-control', 'placeholder': 'http://infinityboulder.it'}),
            'email_address': forms.EmailInput(attrs={'class': 'form-control', 'placeholder': 'infinityboulder@gmail.com'})
        }

# myUser form
class myUserForm(ModelForm):
    class Meta: #django define things
        model = myUser
        # fields = "__all__"
        fields = ('first_name', 'last_name', 'birth_date', 'email')
        labels = {
            'first_name': 'First Name',
            'last_name': 'Last Name',
            'birth_date': 'Birth Date: YYYY-MM-DD',
            'email_address': 'Email Address'
        }
        widgets = {
            'first_name': forms.TextInput(attrs={'class': 'form-control', 'placeholder': 'Anna'}),
            'last_name': forms.TextInput(attrs={'class': 'form-control', 'placeholder': 'Veronese'}),
            'birth_date': forms.DateInput(attrs={'class': 'form-control', 'placeholder': '1999-01-25'}),
            'email_address': forms.EmailInput(attrs={'class': 'form-control', 'placeholder': 'AnnaV@gmail.com'})
        }

class SportForm(ModelForm):
    class Meta: #django define things
        model = Sport
        # fields = "__all__"
        fields = ('name', 'description')
        labels = {
            'name': 'Sport Name',
            'description': 'Sport Description'
        }
        widgets = {
            'name': forms.TextInput(attrs={'class': 'form-control', 'placeholder': 'climbing'}),
            'description': forms.Textarea(attrs={'class': 'form-control', 'placeholder': '...'})
        }

class EventForm(ModelForm):
    class Meta: #django define things
        model = Event
        # fields = "__all__"
        fields = ('name', 'venue', 'start_date', 'end_date', 'description', 'manager', 'attendees', 'sport')
        labels = {
            'name': 'Event Name',
            'venue': 'Select Venue',
            'start_date': 'Start Date and Time: YYYY-MM-DD HH:MM:SS',
            'end_date': 'End Date and Time: YYYY-MM-DD HH:MM:SS',
            'description': 'Description (optional)',
            'manager': 'Select Guide (optional)',
            'attendees': 'Select Multiple Attendees (optional)',
            'sport': 'Select Sport'
        }
        # CHOICES = (('Option 1', 'Option 1'), ('Option 2', 'Option 2'),) # Venue.objects.all()
        widgets = {
            'name': forms.TextInput(attrs={'class': 'form-control', 'placeholder': 'Indoor boulder climbing'}),
            # 'venue': forms.TextInput(attrs={'class': 'form-control', 'placeholder': 'Infinity Boulder: Località Le Basse, 25'}),
            #'venue': forms.ChoiceField(choices=CHOICES),
            'venue': forms.Select(attrs={'class': 'regDropDown'}),
            'start_date': forms.DateTimeInput(attrs={'class': 'form-control', 'placeholder': '2023-10-25 14:30:59'}),
            'end_date': forms.DateTimeInput(attrs={'class': 'form-control', 'placeholder': '2023-10-25 17:30:59'}),
            'description': forms.Textarea(attrs={'class': 'form-control', 'placeholder': '...'}),
            #'manager': forms.TextInput(attrs={'class': 'form-control', 'placeholder': '...'}),
            'manager': forms.Select(attrs={'class': 'regDropDown'}),
            #'attendees': forms.TextInput(attrs={'class': 'form-control', 'placeholder': '...'}),
            'attendees': forms.SelectMultiple(attrs={'class': 'regDropDown'}),
            #'sport': forms.TextInput(attrs={'class': 'form-control', 'placeholder': '...'})
            'sport': forms.Select(attrs={'class': 'regDropDown'})
        }

mysite/events/views.py
from django.shortcuts import render, redirect
from django.http import HttpResponseRedirect

from .models import Event, Venue, myUser, Sport
from .forms import VenueForm, myUserForm, SportForm, EventForm

# calendar:
import calendar
from calendar import HTMLCalendar
from calendar import monthrange
from datetime import datetime,date,timedelta  # https://docs.python.org/3/library/datetime.html
# date = datetime.date
from .models import ContestCalendar  # Contest
from django.views import generic


def home(request):
    return render(request, 'events/home.html', {})

# ---------- view existing items in db

def all_venues(request):
    all_venue = Venue.objects.all()
    return render(request, 'events/venue_list.html', {
        "venue_list": all_venue})


def all_myUsers(request):
    all_myUser = myUser.objects.all()
    return render(request, 'events/myUser_list.html', {
        "myUser_list": all_myUser})


def all_sports(request):
    all_sport = Sport.objects.all()
    return render(request, 'events/sport_list.html', {
        "sport_list": all_sport})


def all_events(request):
    all_event = Event.objects.all()
    return render(request, 'events/event_list.html', {
        "event_list": all_event})

# ----------- ADD items to db

def add_venue(request):
    submitted = False
    if request.method == "POST":
        form = VenueForm(request.POST)
        if form.is_valid():
            form.save()
            return HttpResponseRedirect('/add_venue?submitted=True')
    else:
        form = VenueForm
        if 'submitted' in request.GET:
            submitted = True

    return render(request, 'events/add_venue.html', {
        'form': form, 'submitted': submitted
    })


def add_myUser(request):
    submitted = False
    if request.method == "POST":
        form = myUserForm(request.POST)
        if form.is_valid():
            form.save()
            return HttpResponseRedirect('/add_myUser?submitted=True')
    else:
        form = myUserForm
        if 'submitted' in request.GET:
            submitted = True

    return render(request, 'events/add_myUser.html', {
        'form': form, 'submitted': submitted
    })


def add_sport(request):
    submitted = False
    if request.method == "POST":
        form = SportForm(request.POST)
        if form.is_valid():
            form.save()
            return HttpResponseRedirect('/add_sport?submitted=True')
    else:
        form = SportForm
        if 'submitted' in request.GET:
            submitted = True

    return render(request, 'events/add_sport.html', {
        'form': form, 'submitted': submitted
    })


def add_event(request):
    submitted = False
    if request.method == "POST":
        form = EventForm(request.POST)
        if form.is_valid():
            form.save()
            return HttpResponseRedirect('/add_event?submitted=True')
    else:
        form = EventForm
        if 'submitted' in request.GET:
            submitted = True

    return render(request, 'events/add_event.html', {
        'form': form, 'submitted': submitted
    })

# --------- UPDATE and DELETE items

def update_venue(request, venue_id):
    submitted = False
    venue = Venue.objects.get(pk=venue_id)
    form = VenueForm(request.POST or None, instance=venue)
    if request.method == "POST":
        if form.is_valid():
            form.save()
            # return redirect('list_venues')
            return HttpResponseRedirect('/update_venue/'+venue_id+'?submitted=True')
    else:
        # form = VenueForm()
        if 'submitted' in request.GET:
            submitted = True

    return render(request, 'events/update_venue.html', {
        'submitted': submitted, 'venue': venue, 'form': form
    })


def delete_venue(request, venue_id):
    venue = Venue.objects.get(pk=venue_id)
    venue.delete()
    return redirect('list_venues')


def update_myUser(request, myUser_id):
    submitted = False
    myuser = myUser.objects.get(pk=myUser_id)
    form = myUserForm(request.POST or None, instance=myuser)
    if request.method == "POST":
        if form.is_valid():
            form.save()
            # return redirect('list_myUser')
            return HttpResponseRedirect('/update_myUser/'+myUser_id+'?submitted=True')
    else:
        # form = VenueForm()
        if 'submitted' in request.GET:
            submitted = True

    return render(request, 'events/update_myUser.html', {
        'submitted': submitted, 'myUser': myuser, 'form': form
    })


def delete_myUser(request, myUser_id):
    myuser = myUser.objects.get(pk=myUser_id)
    myuser.delete()
    return redirect('list_users')


def update_sport(request, sport_id):
    submitted = False
    sport = Sport.objects.get(pk=sport_id)
    form = SportForm(request.POST or None, instance=sport)
    if request.method == "POST":
        if form.is_valid():
            form.save()
            return HttpResponseRedirect('/update_sport/'+sport_id+'?submitted=True')
    else:
        if 'submitted' in request.GET:
            submitted = True

    return render(request, 'events/update_sport.html', {
        'submitted': submitted, 'sport': sport, 'form': form
    })


def delete_sport(request, sport_id):
    sport = Sport.objects.get(pk=sport_id)
    sport.delete()
    return redirect('list_sports')


def update_event(request, event_id):
    submitted = False
    event = Event.objects.get(pk=event_id)
    form = EventForm(request.POST or None, instance=event)
    if request.method == "POST":
        if form.is_valid():
            form.save()
            return HttpResponseRedirect('/update_event/'+event_id+'?submitted=True')
    else:
        if 'submitted' in request.GET:
            submitted = True

    return render(request, 'events/update_event.html', {
        'submitted': submitted, 'event': event, 'form': form
    })


def delete_event(request, event_id):
    event = Event.objects.get(pk=event_id)
    event.delete()
    return redirect('list_events')

#-------------

def search_event(request):
    if request.method == 'POST':
        event_searched = request.POST['event_searched']
        events = Event.object.filter(name__contains=event_searched)
        return render(request, 'event/search_event.html', {'event_searched': event_searched, 'events': events})
    else:
        return render(request, 'event/search_event.html', {})

class EventView(generic.DetailView): # display a detail page for a particular type of object
    model = Event
    template_name = 'events/event_detail.html'
 
# ---------- calendar : STATIC
"""
def calendar2(request, year = datetime.now().year, month = datetime.now().strftime('%B')):
    month = month.capitalize() # .title()
    # convert month from name to number
    month_number = datetime.strptime(month, '%B').month # not case sensitive !! But is better to capitalize it anyway
    month_number = int(month_number) # cast to be sure it will be an integer
    # month_number = list(calendar.month_name).index(month) # does not work with lower case initial months -> case sensitive
    cal = HTMLCalendar().formatmonth(year, month_number) # create a calendar associated to variable cal

    now = datetime.now()
    current_year = now.year
    time = now.strftime('%I:%M %p') # :%S seconds

    return render(request, 'events/calendar.html', {
        "year": year, "month": month, "month_number": month_number, "cal": cal,
        "current_year": current_year, "time": time,
    })
"""
""" import calendar     tc= calendar.HTMLCalendar(firstweekday=0)       print(tc.formatmonth(2016, 5))"""

# ---------- calendar : Dynamic:
"""We need to create an instance of this class from our view, passing in the list of objects from the specified month. 
Here I'm using two view functions, one of which calls the other. 
There is also a named_month function which returns the name of a month given the month number.
monthrange(pYear, pMonth) returns a tuple of the day numbers in the month, ie (1,31) for December."""


def named_month(pMonthNumber):
    """ Return the name of the month, given the month number"""
    return date(1900, pMonthNumber, 1).strftime('%B')


def calendar_now(request):
    """ Show calendar of events this month"""
    lToday = datetime.now()
    return calendar(request, lToday.year, lToday.month)


def calendar(request, pYear=datetime.now().year, pMonth=datetime.now().month):
    """ Show calendar of events for specified month and year """
    lYear = int(pYear)
    lMonth = int(pMonth)
    
    lCalendarFromMonth = datetime(lYear, lMonth, 1)
    lCalendarToMonth = datetime(lYear, lMonth, monthrange(lYear, lMonth)[1])

   # lContestEvents = Event.objects.filter(start_date=lCalendarFromMonth, end_date=lCalendarToMonth)
    lContestEvents = Event.objects.filter(start_date__gte=lCalendarFromMonth, end_date__lte=lCalendarToMonth)
    lCalendar = ContestCalendar(lContestEvents).formatmonth(lYear, lMonth)  # formatday(self, day, events) #
    lPreviousYear = lYear
    lPreviousMonth = lMonth - 1

    if lPreviousMonth == 0:
        lPreviousMonth = 12
        lPreviousYear = lYear - 1
    lNextYear = lYear
    lNextMonth = lMonth + 1

    if lNextMonth == 13:
        lNextMonth = 1
        lNextYear = lYear + 1
    lYearAfterThis = lYear + 1
    lYearBeforeThis = lYear - 1

    return render(request, 'events/calendar.html', {'Calendar': (lCalendar),
                                                    'Month': lMonth,
                                                    'MonthName': named_month(lMonth),
                                                    'Year': lYear,
                                                    'PreviousMonth': lPreviousMonth,
                                                    'PreviousMonthName': named_month(lPreviousMonth),
                                                    'PreviousYear': lPreviousYear,
                                                    'NextMonth': lNextMonth,
                                                    'NextMonthName': named_month(lNextMonth),

mysite/events/templates/events/add_Sport.html
{% extends 'events/base.html' %}
    {% block content %}
        <center>
         <h1>Add a Sport to Db</h1>
            <br/><br/>
            {% if submitted %}
                Your Sport Was Submitted Succesfully!

                View All Sports here:
                <a href="{% url 'list_sports' %}" class="btn btn-primary">Existing Sports</a>

            {% else %}
                <form action ="" method=POST>
                {% csrf_token %}
                {{ form.as_p }}
                <!-- bootstrap buttons -->
                    <br/><br/>
                <input type="submit" value="Submit" class="btn btn-secondary">
                    <br/><br/>
            </form>
            {% endif %}

         </center>
    {% endblock %}

mysite/events/templates/events/add_event.html
{% extends 'events/base.html' %}
    {% block content %}
        <center>
         <h1>Add an Event to Db</h1>
            <br/><br/>
            {% if submitted %}
                Your Event Was Submitted Succesfully!

                View All Events here:
                <a href="{% url 'list_events' %}" class="btn btn-primary">Existing Events</a>

            {% else %}
                <form action ="" method=POST>
                {% csrf_token %}
                {{ form.as_p }}
                <!-- bootstrap buttons -->
                    <br/><br/>
                <input type="submit" value="Submit" class="btn btn-secondary">
                    <br/><br/>
            </form>
            {% endif %}

         </center>
    {% endblock %}

mysite/events/templates/events/add_venue.html
{% extends 'events/base.html' %}
    {% block content %}
        <center>
         <h1>Add Venue to Db</h1>
            <br/><br/>
            {% if submitted %}
                Your Venue Was Submitted Succesfully!

                View All Venues here:
                <a href="{% url 'list_venues' %}" class="btn btn-primary">Existing Venues</a>

            {% else %}
                <form action ="" method=POST>
                {% csrf_token %}
                {{ form.as_p }}
                <!-- bootstrap buttons -->
                    <br/><br/>
                <input type="submit" value="Submit" class="btn btn-secondary">
                    <br/><br/>
            </form>
            {% endif %}

         </center>
    {% endblock %}

mysite/events/templates/events/calendar.html
{% extends 'events/base.html' %}
    {% block content %}
        <center>
            <div style="padding-bottom: 30px;">  <!-- 
              <h1>Events for {{month}} {{year}}</h1>
            </div>
            <div>
                {{ cal|safe }}
            </br></br>
            </div> 
            <div>
                {{ cal|safe }}
            </br></br>
            </div>
                <table border="0" cellpadding="0" cellspacing="0" class="month">
                    <tr><th colspan="7" class="month">May 2016</th></tr>
                    <tr><th class="mon">Mon</th><th class="tue">Tue</th><th class="wed">Wed</th><th class="thu">Thu</th><th class="fri">Fri</th><th class="sat">Sat</th><th class="sun">Sun</th></tr>
                    <tr><td class="noday"> </td><td class="noday"> </td><td class="noday"> </td><td class="noday"> </td><td class="noday"> </td><td class="noday"> </td><td class="sun">1</td></tr>
                    <tr><td class="mon">2</td><td class="tue">3</td><td class="wed">4</td><td class="thu">5</td><td class="fri">6</td><td class="sat">7</td><td class="sun">8</td></tr>
                    <tr><td class="mon">9</td><td class="tue">10</td><td class="wed">11</td><td class="thu">12</td><td class="fri">13</td><td class="sat">14</td><td class="sun">15</td></tr>
                    <tr><td class="mon">16</td><td class="tue">17</td><td class="wed">18</td><td class="thu">19</td><td class="fri">20</td><td class="sat">21</td><td class="sun">22</td></tr>
                    <tr><td class="mon">23</td><td class="tue">24</td><td class="wed">25</td><td class="thu">26</td><td class="fri">27</td><td class="sat">28</td><td class="sun">29</td></tr>
                    <tr><td class="mon">30</td><td class="tue">31</td><td class="noday"> </td><td class="noday"> </td><td class="noday"> </td><td class="noday"> </td><td class="noday"> </td></tr>
                </table>   
            <div>
-->
            <div>
                <h1>Calendar for {{MonthName}} {{Year}}</h1> </br>
                    <table width="100%">
                        <tr>
                            <td width="20%" align="left">
                                &lt;&lt; <a href="/calendar/{{YearBeforeThis}}/{{Month}}">{{MonthName}} {{YearBeforeThis}}</a>
                                </td>
                            <td width="20%" align="left">
                            &lt;&lt; <a href="/calendar/{{PreviousYear}}/{{PreviousMonth}}">{{PreviousMonthName}} {{PreviousYear}}</a>
                            </td>
                            <td width="20%" align="center"><a href="/calendar">Today</a></td>
                            <td width="20%" align="right">
                            <a href="/calendar/{{NextYear}}/{{NextMonth}}">{{NextMonthName}} {{NextYear}}</a> &gt;&gt;
                            </td>
                            <td width="20%" align="right">
                                <a href="/calendar/{{YearAfterThis}}/{{Month}}">{{MonthName}} {{YearAfterThis}}</a> &gt;&gt;
                                </td>
                        </tr>
                    </table>
                    <div id="calendar">
                        <br/>
                        {{ Calendar|safe }}
                    </div>
            </div>
               
            </div>

        </center>

    {% endblock %}

mysite/events/templates/events/event_detail.html
{% extends 'events/base.html' %}
{% block content %}
   <div class="ml-auto card w-50" style="width: 35rem;"> 
        <div class="card-body">
            <h5 class="card-title"><strong>{{ event.name }}</strong></h5>
            <p class="card-text">
                <ul>
                  <li><strong>Event Start: </strong>{{ event.start_date }}</li>
                  <li><strong>Event End: </strong>{{ event.end_date }}</li>
                  <li><strong>Venue: </strong>{{ event.venue }}</li>
            <!--  <li><strong>Venue Address: </strong>{{ event.venue.address }}</li>  -->
                {% if event.manager %}
                  <li><strong>Event Guide: </strong>{{ event.manager }}</li>
                {% endif %}
                {% if event.description %}
                  <li><strong>Description: </strong>{{ event.description }}</li>
                {% endif %}
                {% if event.sport %}
                  <li><strong>Sport: </strong>{{ event.sport }}</li>
                {% endif %}
                  <li><strong>Attendees: </strong>
                    {% for user in event.attendees.all %}
                     {{ user }},
                    {% endfor %}
                  </li>
              </ul>
            </p>
            <a href="{% url 'update_event' event.id %}" class="btn btn-primary" style ="background-color: #4CAF50; border-color: #4CAF50">Update</a>
            <a href="{% url 'delete_event' event.id %}" class="btn btn-primary" style ="background-color: #f44336; border-color: #f44336">Delete</a>
        </div>
      </div>
      <br/>

{% endblock %}

mysite/events/templates/events/event_list.html
{% extends 'events/base.html' %}
    {% block content %}
    <center> <h1>Events</h1> <br/> </center>
      <div class="row justify-content-center"> <!-- col d-flex justify-content-center -->
               {% if event_list %}
                 {% for event in event_list %}
                    <div class="ml-auto card w-50" style="width: 35rem;"> 
                        <div class="card-body">
                            <h5 class="card-title"><strong>{{ event }}</strong></h5>
                            <p class="card-text">
                                <ul>
                                  <li><strong>Event Start: </strong>{{ event.start_date }}</li>
                                  <li><strong>Event End: </strong>{{ event.end_date }}</li>
                                  <li><strong>Venue: </strong>{{ event.venue }}</li>
                            <!--  <li><strong>Venue Address: </strong>{{ event.venue.address }}</li>  -->
                                {% if event.manager %}
                                  <li><strong>Event Guide: </strong>{{ event.manager }}</li>
                                {% endif %}
                                {% if event.description %}
                                  <li><strong>Description: </strong>{{ event.description }}</li>
                                {% endif %}
                                {% if event.sport %}
                                  <li><strong>Sport: </strong>{{ event.sport }}</li>
                                {% endif %}
                                  <li><strong>Attendees: </strong>
                                    {% for user in event.attendees.all %}
                                     {{ user }},
                                    {% endfor %}
                                  </li>
                              </ul>
                            </p>
                            <a href="{% url 'update_event' event.id %}" class="btn btn-primary" style ="background-color: #4CAF50; border-color: #4CAF50">Update</a>
                            <a href="{% url 'delete_event' event.id %}" class="btn btn-primary" style ="background-color: #f44336; border-color: #f44336">Delete</a>
                        </div>
                      </div>
                      <br/>
                
                {% endfor %}
                {% else %}
                <div class="card" style="width: 35rem;">
                    <div class="card-body">
                            <h5 class="card-title"><strong>No events are available.</strong></h5>
                            <p class="card-text">
                            </p>
                            Add an Event here:
                            <a href="{% url 'add_event' %}" class="btn btn-primary">New Event</a>
                        </div>
                      </div>
                <p></p>
                {% endif %}
            
      </div>
    {% endblock %}

mysite/events/templates/events/navbar.html
<!-- Bootstrap https://getbootstrap.com/docs/5.0/components/navbar/ --> <!--  -->
<!-- {% url 'calendar' '2022' '3' %} -->
<nav class="navbar navbar-expand-lg navbar-dark bg-dark">
  <div class="container-fluid">
    <a class="navbar-brand" href="{% url 'home' %}">Home</a>
    <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
      <span class="navbar-toggler-icon"></span>
    </button>
    <div class="collapse navbar-collapse" id="navbarSupportedContent">
      <ul class="navbar-nav me-auto mb-2 mb-lg-0">
        <li class="nav-item">
          <a class="nav-link active" aria-current="page" href="{% url 'calendar' %}">Calendar</a> 
        </li>
        <li class="nav-item">
          <a class="nav-link" href="{% url 'polls:index' %}">Polls</a>
        </li>
        <li class="nav-item"> 
          <a class="nav-link" href="/admin/">Admin</a>
        </li>
        <!--
        <li class="nav-item">
          <a class="nav-link" href="{% url 'list_events' %}">Events</a>
        </li>
        <li class="nav-item">
          <a class="nav-link" href="#">Link</a>
        </li> -->
        <li class="nav-item dropdown">
          <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown1" role="button" data-bs-toggle="dropdown" aria-expanded="false">
            Add new
          </a>
          <ul class="dropdown-menu" aria-labelledby="navbarDropdown">
            <li><a class="dropdown-item" href="{% url 'add_venue' %}">Venue</a></li>
            <li><a class="dropdown-item" href="{% url 'add_myUser' %}">User</a></li>
            <li><a class="dropdown-item" href="{% url 'add_sport' %}">Sport</a></li>
            <li><a class="dropdown-item" href="{% url 'add_event' %}">Event</a></li>
             <!-- <li><hr class="dropdown-divider"></li> -->
          </ul>
        </li>
        <li class="nav-item dropdown">
          <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown2" role="button" data-bs-toggle="dropdown" aria-expanded="false">
            View existing
          </a>
          <ul class="dropdown-menu" aria-labelledby="navbarDropdown">
            <li><a class="dropdown-item" href="{% url 'list_venues' %}">Venues</a></li>
            <li><a class="dropdown-item" href="{% url 'list_users' %}">Users</a></li>
            <li><a class="dropdown-item" href="{% url 'list_sports' %}">Sports</a></li>
            <li><a class="dropdown-item" href="{% url 'list_events' %}">Events</a></li>
          </ul>
        </li>
      </ul>
      <!-- <form class="d-flex" method="POST" action ="{% url 'search_event' %}">
        {% csrf_token %}
        <input class="form-control me-2" type="search" placeholder="Search Events" aria-label="Search" name="event_searched">
        <button class="btn btn-outline-success" type="submit">Search</button>
      </form> -->

    </div>
  </div>
</nav>

mysite/events/templates/events/update_event.html
{% extends 'events/base.html' %}
    {% block content %}
        <center>
         <h1>Update Existing Events</h1>
            <br/>
            {% if submitted %}
                Your Event Was Updated Succesfully!

                View All Events here:
                <a href="{% url 'list_events' %}" class="btn btn-primary">Existing Events</a>

            {% else %}
                <form action="" method=POST>
                {% csrf_token %}
                {{ form.as_p }}
                <br/>
                <input type="submit" value= "Update" class="btn btn-secondary">
                <br/>
                </form>
            {% endif %}

         </center>
    {% endblock %}